package lt.bit;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import lt.bit.dao.CountryDAO;
import lt.bit.models.Country;
import java.awt.GridLayout;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class RodytiSaly extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private Country country;
	private JTextField tfContinent;
	private JTextField tfPopulation;
	private JTextField tfRegion;
	private JTextField tfName;
	private JTextField tfLifeExpectancy;
	private JTextField tfSurfaceArea;

	

	/**
	 * Create the dialog.
	 */
	public RodytiSaly(PagrindinisLangas tevinis, Country country) {
		super(tevinis,"Šalies redagavimas", JDialog.ModalityType.DOCUMENT_MODAL);
		this.country=country;
		
		
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new GridLayout(6, 2, 10, 0));
		{
			JLabel lblNewLabel = new JLabel("Pavadinimas:");
			lblNewLabel.setHorizontalAlignment(SwingConstants.RIGHT);
			contentPanel.add(lblNewLabel);
		}
		{
			tfName = new JTextField(this.country.getName());
			contentPanel.add(tfName);
			tfName.setColumns(10);
		}
		{
			JLabel lblNewLabel_1 = new JLabel("Kontinentas:");
			lblNewLabel_1.setHorizontalAlignment(SwingConstants.RIGHT);
			contentPanel.add(lblNewLabel_1);
		}
		{
			tfContinent = new JTextField(this.country.getContinent());
			contentPanel.add(tfContinent);
			tfContinent.setColumns(10);
		}
		{
			JLabel lblNewLabel_5 = new JLabel("Regionas:");
			lblNewLabel_5.setHorizontalAlignment(SwingConstants.RIGHT);
			contentPanel.add(lblNewLabel_5);
		}
		{
			tfRegion = new JTextField(this.country.getRegion());
			contentPanel.add(tfRegion);
			tfRegion.setColumns(10);
		}
		{
			JLabel lblNewLabel_4 = new JLabel("Plotas:");
			lblNewLabel_4.setHorizontalAlignment(SwingConstants.RIGHT);
			contentPanel.add(lblNewLabel_4);
		}
		{
			tfSurfaceArea = new JTextField(this.country.getSurfaceArea().toString());
			contentPanel.add(tfSurfaceArea);
			tfSurfaceArea.setColumns(10);
		}
		{
			JLabel lblNewLabel_3 = new JLabel("Populiacija");
			lblNewLabel_3.setHorizontalAlignment(SwingConstants.RIGHT);
			contentPanel.add(lblNewLabel_3);
		}
		{
			tfPopulation = new JTextField(this.country.getPopulation().toString());
			contentPanel.add(tfPopulation);
			tfPopulation.setColumns(10);
		}
		{
			JLabel lblNewLabel_2 = new JLabel("Gyvenimo trukmė:");
			lblNewLabel_2.setHorizontalAlignment(SwingConstants.RIGHT);
			contentPanel.add(lblNewLabel_2);
		}
		{
			tfLifeExpectancy = new JTextField(this.country.getLifeExpectancy().toString());
			contentPanel.add(tfLifeExpectancy);
			tfLifeExpectancy.setColumns(10);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton btSave = new JButton("Išsaugoti");
				btSave.addActionListener((e)->{
					this.country.setName(tfName.getText());
					this.country.setRegion(tfRegion.getText());
					this.country.setContinent(tfContinent.getText());
					this.country.setSurfaceArea( Double.parseDouble(tfSurfaceArea.getText()));
					this.country.setPopulation(Integer.parseInt(tfPopulation.getText()));
					this.country.setLifeExpectancy(Double.parseDouble(tfLifeExpectancy.getText()));
					
					
					CountryDAO countryDAO=new CountryDAO();
					countryDAO.updateCountry(this.country);
					
					
					tevinis.list.updateUI();
					
					setVisible(false);
					dispose();
				});
				
				buttonPane.add(btSave);
				getRootPane().setDefaultButton(btSave);
			}
			{
				JButton btDelete = new JButton("Ištrinti");
				btDelete.addActionListener((e)->{
					CountryDAO countryDAO=new CountryDAO();
					countryDAO.deleteCountry( this.country );
					tevinis.list.setListData(countryDAO.getCountries().toArray());
					tevinis.list.updateUI();
					
					setVisible(false);
					dispose();
				});
				
				buttonPane.add(btDelete);
			}
		}
	}

}
