package lt.bit.dao;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.LinkedList;
import java.util.List;

import lt.bit.db.MySQL;
import lt.bit.models.Country;

public class CountryDAO {

	public CountryDAO() {

	}

	public List<Country> getCountries() {
		PreparedStatement s;
		try {
			s = MySQL.getConnection().prepareStatement("SELECT * FROM country ORDER BY Name ASC");
			ResultSet r = s.executeQuery();
			List<Country> countries = new LinkedList<>();
			while (r.next()) {
				countries.add(
						new Country(
								r.getString("Code"), 
								r.getString("Name"), 
								r.getString("Continent"),
								r.getString("Region"), 
								r.getDouble("SurfaceArea"), 
								r.getInt("Population"),
								r.getDouble("LifeExpectancy"))
						);
			}
			return countries;

		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

	public Country getCountry(String code) {
		PreparedStatement s;
		try {
			s = MySQL.getConnection().prepareStatement("SELECT * FROM country WHERE code=?");

			s.setString(1, code);
			ResultSet r = s.executeQuery();
			r.next();
			return new Country(r.getString("Code"), r.getString("Name"), r.getString("Continent"),
					r.getString("Region"), r.getDouble("SurfaceArea"), r.getInt("Population"),
					r.getDouble("LifeExpectancy"));
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public void updateCountry(Country country) {
		// 
		PreparedStatement s;
		try {
			s = MySQL.getConnection().prepareStatement("UPDATE country SET name=?, continent=?, region=?, surfaceArea=?, population=?, lifeExpectancy=? WHERE code=?");

			s.setString(1, country.getName());
			s.setString(2, country.getContinent());
			s.setString(3, country.getRegion());
			s.setDouble(4, country.getSurfaceArea());
			s.setInt(5, country.getPopulation());
			s.setDouble(6, country.getLifeExpectancy());
			s.setString(7, country.getCode());
			s.executeUpdate();
			
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}
	
	public void addCountry(Country country) {
		PreparedStatement s;
		try {
			
			s = MySQL.getConnection().prepareStatement("INSERT INTO country (code, name, continent,region, surfaceArea, population, lifeExpectancy) VALUES (?, ?,?, ?, ?, ?, ?)");

			s.setString(1, country.getCode());
			s.setString(2, country.getName());
			s.setString(3, country.getContinent());
			s.setString(4, country.getRegion());
			s.setDouble(5, country.getSurfaceArea());
			s.setInt(6, country.getPopulation());
			s.setDouble(7, country.getLifeExpectancy());
			
			
			s.execute();
			
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public void deleteCountry(Country country) {
		PreparedStatement s;
		try {
			
			s = MySQL.getConnection().prepareStatement("DELETE FROM country WHERE code=?");
			s.setString(1, country.getCode());
			s.execute();
			
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

}
